javax.xml.ws

## Interface BindingProvider

- All Known Subinterfaces:
    Dispatch<T>

      public interface BindingProvider

  The `BindingProvider` interface provides access to the protocol binding and associated context objects for request and response message processing.
  Since:
    JAX-WS 2.0
  See Also:
    `Binding`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `ENDPOINT_ADDRESS_PROPERTY` | Standard property: Target service endpoint address.
    `static String` | `PASSWORD_PROPERTY` | Standard property: Password for authentication.
    `static String` | `SESSION_MAINTAIN_PROPERTY` | Standard property: This boolean property is used by a service client to indicate whether or not it wants to participate in a session with a service endpoint.
    `static String` | `SOAPACTION_URI_PROPERTY` | Standard property for SOAPAction.
    `static String` | `SOAPACTION_USE_PROPERTY` | Standard property for SOAPAction.
    `static String` | `USERNAME_PROPERTY` | Standard property: User name for authentication.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Binding` | `getBinding()` | Get the Binding for this binding provider.
    `EndpointReference` | `getEndpointReference()` | Returns the `EndpointReference` associated with this `BindingProvider` instance.
    `<T extends EndpointReference> T` | `getEndpointReference(Class<T> clazz)` | Returns the `EndpointReference` associated with this `BindingProvider` instance.
    `Map<String,Object>` | `getRequestContext()` | Get the context that is used to initialize the message context for request messages.
    `Map<String,Object>` | `getResponseContext()` | Get the context that resulted from processing a response message.

- - ### Field Detail

    - #### USERNAME_PROPERTY

          static final String USERNAME_PROPERTY

      Standard property: User name for authentication.

      Type: `java.lang.String`

      See Also:
        Constant Field Values

    - #### PASSWORD_PROPERTY

          static final String PASSWORD_PROPERTY

      Standard property: Password for authentication.

      Type: `java.lang.String`

      See Also:
        Constant Field Values

    - #### ENDPOINT_ADDRESS_PROPERTY

          static final String ENDPOINT_ADDRESS_PROPERTY

      Standard property: Target service endpoint address. The URI scheme for the endpoint address specification MUST correspond to the protocol/transport binding for the binding in use.

      Type: `java.lang.String`

      See Also:
        Constant Field Values

    - #### SESSION_MAINTAIN_PROPERTY

          static final String SESSION_MAINTAIN_PROPERTY

      Standard property: This boolean property is used by a service client to indicate whether or not it wants to participate in a session with a service endpoint. If this property is set to `true`, the service client indicates that it wants the session to be maintained. If set to `false`, the session is not maintained. The default value for this property is `false`.

      Type: `java.lang.Boolean`

      See Also:
        Constant Field Values

    - #### SOAPACTION_USE_PROPERTY

          static final String SOAPACTION_USE_PROPERTY

      Standard property for SOAPAction. This boolean property indicates whether or not the value of the `javax.xml.ws.soap.http.soapaction.uri` property is used for the value of the SOAPAction. The default value of this property is `false` indicating that the `javax.xml.ws.soap.http.soapaction.uri` property is not used for the value of the SOAPAction, however, if WS-Addressing is enabled, the default value is `true`.

      Type: `java.lang.Boolean`

      See Also:
        Constant Field Values

    - #### SOAPACTION_URI_PROPERTY

          static final String SOAPACTION_URI_PROPERTY

      Standard property for SOAPAction. Indicates the SOAPAction URI if the `javax.xml.ws.soap.http.soapaction.use` property is set to `true`. If WS-Addressing is enabled, this value will also be used for the value of the WS-Addressing Action header. If this property is not set, the default SOAPAction and WS-Addressing Action will be sent.

      Type: `java.lang.String`

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getRequestContext

          Map<String,Object> getRequestContext()

      Get the context that is used to initialize the message context for request messages. Modifications to the request context do not affect the message context of either synchronous or asynchronous operations that have already been started.
      Returns:
        The context that is used in processing request messages.

    - #### getResponseContext

          Map<String,Object> getResponseContext()

      Get the context that resulted from processing a response message. The returned context is for the most recently completed synchronous operation. Subsequent synchronous operation invocations overwrite the response context. Asynchronous operations return their response context via the Response interface.
      Returns:
        The context that resulted from processing the latest response messages.

    - #### getBinding

          Binding getBinding()

      Get the Binding for this binding provider.
      Returns:
        The Binding for this binding provider.

    - #### getEndpointReference

          EndpointReference getEndpointReference()

      Returns the `EndpointReference` associated with this `BindingProvider` instance.

      If the Binding for this `bindingProvider` is either SOAP1.1/HTTP or SOAP1.2/HTTP, then a `W3CEndpointReference` MUST be returned.

      Returns:
        EndpointReference of the target endpoint associated with this `BindingProvider` instance.
      Throws:
        `UnsupportedOperationException` - If this `BindingProvider` uses the XML/HTTP binding.
      Since:
        JAX-WS 2.1
      See Also:
        `W3CEndpointReference`

    - #### getEndpointReference

          <T extends EndpointReference> T getEndpointReference(Class<T> clazz)

      Returns the `EndpointReference` associated with this `BindingProvider` instance. The instance returned will be of type `clazz`.
      Parameters:
        `clazz` - Specifies the type of `EndpointReference` that MUST be returned.
      Returns:
        EndpointReference of the target endpoint associated with this `BindingProvider` instance. MUST be of type `clazz`.
      Throws:
        `WebServiceException` - If the Class `clazz` is not supported by this implementation.
        `UnsupportedOperationException` - If this `BindingProvider` uses the XML/HTTP binding.
      Since:
        JAX-WS 2.1

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.